#include "MontjoieFlag.hxx"

#include "FiniteElement/MontjoieFiniteElementHeader.hxx"
#include "FiniteElement/MontjoieFiniteElementInline.hxx"

#ifndef SELDON_WITH_COMPILED_LIBRARY
#include "FiniteElement/FiniteElementH1.cxx"
#endif

namespace Montjoie
{

  SELDON_EXTERN template class FiniteElementH1<Dimension2>;
  SELDON_EXTERN template class FiniteElementH1<Dimension3>;

  SELDON_EXTERN template void FiniteElementH1<Dimension2>::GetCurlFromGradient(const Vector<VectReal_wp>&, Vector<VectReal_wp>&);
  SELDON_EXTERN template void FiniteElementH1<Dimension2>::GetCurlFromGradient(const Vector<VectComplex_wp>&, Vector<VectComplex_wp>&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeNodalValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
						       const Vector<VectReal_wp>&, Vector<VectReal_wp>&,
						       const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeNodalValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
						       const Vector<VectComplex_wp>&, Vector<VectComplex_wp>&,
						       const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&, int) const;
    
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeQuadratureValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							    const Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							    Vector<VectReal_wp >&, bool, bool, const ElementReference<Dimension2, 1>&,
							    const Mesh<Dimension2>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeQuadratureValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							    const Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							    Vector<VectComplex_wp >&, bool, bool, const ElementReference<Dimension2, 1>&,
							    const Mesh<Dimension2>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeProjectionDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							 Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							 const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							 const MeshNumbering<Dimension2>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeProjectionDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							 Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							 const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							 const MeshNumbering<Dimension2>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeProjectionSurfaceDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>& ,
								Vector<VectReal_wp >&, Vector<VectReal_wp >&,
								const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
								const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeProjectionSurfaceDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>& ,
								Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
								const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
								const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegral(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
						    Vector<VectReal_wp >&, Vector<VectReal_wp >&,
						    const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
						    const MeshNumbering<Dimension2>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegral(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
						    Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
						    const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
						    const MeshNumbering<Dimension2>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							    Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							    const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							    const MeshNumbering<Dimension2>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							    Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							    const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							    const MeshNumbering<Dimension2>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurface(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							   Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							   const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							   const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurface(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							   Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							   const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							   const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurfaceHDG(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							      Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							      const ElementReference<Dimension2, 1>&, const ElementReference<Dimension1, 1>&, const Mesh<Dimension2>&,
							      const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurfaceHDG(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							      Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							      const ElementReference<Dimension2, 1>&, const ElementReference<Dimension1, 1>&, const Mesh<Dimension2>&,
							      const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurface(const Vector<Matrix2_2>&, const VectReal_wp&, const VectReal_wp&,
							   Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							   const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							   const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurface(const Vector<Matrix2_2>&, const VectReal_wp&, const VectReal_wp&,
							   Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							   const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
							   const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeGaussIntegralSurface(const Vector<Matrix2_2>&, const VectReal_wp&, const VectReal_wp&,
								Vector<VectReal_wp >&, Vector<VectReal_wp >&,
								const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
								const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeGaussIntegralSurface(const Vector<Matrix2_2>&, const VectReal_wp&, const VectReal_wp&,
								Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
								const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&,
								const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurfaceGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
								   Vector<VectReal_wp >&, Vector<VectReal_wp >&, const ElementReference<Dimension2, 1>&,
								   const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeIntegralSurfaceGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
								   Vector<VectComplex_wp >&, Vector<VectComplex_wp >&, const ElementReference<Dimension2, 1>&,
								   const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeValueNodalBoundary(const VectReal_wp&, VectReal_wp&, const ElementReference<Dimension2, 1>&,
							      const Mesh<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeValueNodalBoundary(const VectComplex_wp&, VectComplex_wp&, const ElementReference<Dimension2, 1>&,
							      const Mesh<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeValueBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							 const Vector<VectReal_wp >&, Vector<Vector<TinyVector<Real_wp, 1> > >& res,
							 const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeValueBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							 const Vector<VectComplex_wp >&, Vector<Vector<TinyVector<Complex_wp, 1> > >& res,
							 const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&, int, int) const;
    
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeGradientBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							    const Vector<VectReal_wp >&, Vector<Vector<TinyVector<Real_wp, 2> > >&,
							    const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ComputeGradientBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
							    const Vector<VectComplex_wp >&, Vector<Vector<TinyVector<Complex_wp, 2> > >&,
							    const ElementReference<Dimension2, 1>&, const Mesh<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ApplyRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Real_wp, 1>&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ApplyRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Complex_wp, 1>&);
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Real_wp, 1>&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Complex_wp, 1>&);
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, VectReal_wp&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension2>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, VectComplex_wp&);


  SELDON_EXTERN template void FiniteElementH1<Dimension3>::GetCurlFromGradient(const Vector<VectReal_wp>&, Vector<VectReal_wp>&);
  SELDON_EXTERN template void FiniteElementH1<Dimension3>::GetCurlFromGradient(const Vector<VectComplex_wp>&, Vector<VectComplex_wp>&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeNodalValues(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
						       const Vector<VectReal_wp>&, Vector<VectReal_wp>&,
						       const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeNodalValues(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
						       const Vector<VectComplex_wp>&, Vector<VectComplex_wp>&,
						       const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&, int) const;
    
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeQuadratureValues(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							    const Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							    Vector<VectReal_wp >&, bool, bool, const ElementReference<Dimension3, 1>&,
							    const Mesh<Dimension3>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeQuadratureValues(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							    const Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							    Vector<VectComplex_wp >&, bool, bool, const ElementReference<Dimension3, 1>&,
							    const Mesh<Dimension3>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeProjectionDof(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							 Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							 const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							 const MeshNumbering<Dimension3>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeProjectionDof(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							 Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							 const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							 const MeshNumbering<Dimension3>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeProjectionSurfaceDof(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>& ,
								Vector<VectReal_wp >&, Vector<VectReal_wp >&,
								const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
								const MeshNumbering<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeProjectionSurfaceDof(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>& ,
								Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
								const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
								const MeshNumbering<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegral(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
						    Vector<VectReal_wp >&, Vector<VectReal_wp >&,
						    const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
						    const MeshNumbering<Dimension3>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegral(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
						    Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
						    const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
						    const MeshNumbering<Dimension3>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralGradient(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							    Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							    const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							    const MeshNumbering<Dimension3>&, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralGradient(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							    Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							    const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							    const MeshNumbering<Dimension3>&, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurface(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							   Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							   const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							   const MeshNumbering<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurface(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							   Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							   const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							   const MeshNumbering<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurfaceHDG(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							      Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							      const ElementReference<Dimension3, 1>&, const ElementReference<Dimension2, 1>&, const Mesh<Dimension3>&,
							      const MeshNumbering<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurfaceHDG(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							      Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							      const ElementReference<Dimension3, 1>&, const ElementReference<Dimension2, 1>&, const Mesh<Dimension3>&,
							      const MeshNumbering<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurface(const Vector<Matrix3_3>&, const VectReal_wp&, const VectReal_wp&,
							   Vector<VectReal_wp >&, Vector<VectReal_wp >&,
							   const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							   const MeshNumbering<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurface(const Vector<Matrix3_3>&, const VectReal_wp&, const VectReal_wp&,
							   Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
							   const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
							   const MeshNumbering<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeGaussIntegralSurface(const Vector<Matrix3_3>&, const VectReal_wp&, const VectReal_wp&,
								Vector<VectReal_wp >&, Vector<VectReal_wp >&,
								const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
								const MeshNumbering<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeGaussIntegralSurface(const Vector<Matrix3_3>&, const VectReal_wp&, const VectReal_wp&,
								Vector<VectComplex_wp >&, Vector<VectComplex_wp >&,
								const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&,
								const MeshNumbering<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurfaceGradient(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
								   Vector<VectReal_wp >&, Vector<VectReal_wp >&, const ElementReference<Dimension3, 1>&,
								   const Mesh<Dimension3>&, const MeshNumbering<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeIntegralSurfaceGradient(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
								   Vector<VectComplex_wp >&, Vector<VectComplex_wp >&, const ElementReference<Dimension3, 1>&,
								   const Mesh<Dimension3>&, const MeshNumbering<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeValueNodalBoundary(const VectReal_wp&, VectReal_wp&, const ElementReference<Dimension3, 1>&,
							      const Mesh<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeValueNodalBoundary(const VectComplex_wp&, VectComplex_wp&, const ElementReference<Dimension3, 1>&,
							      const Mesh<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeValueBoundary(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							 const Vector<VectReal_wp >&, Vector<Vector<TinyVector<Real_wp, 1> > >& res,
							 const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeValueBoundary(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							 const Vector<VectComplex_wp >&, Vector<Vector<TinyVector<Complex_wp, 1> > >& res,
							 const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&, int, int) const;
    
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeGradientBoundary(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							    const Vector<VectReal_wp >&, Vector<Vector<TinyVector<Real_wp, 3> > >&,
							    const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&, int, int) const;

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ComputeGradientBoundary(const SetPoints<Dimension3>&, const SetMatrices<Dimension3>&,
							    const Vector<VectComplex_wp >&, Vector<Vector<TinyVector<Complex_wp, 3> > >&,
							    const ElementReference<Dimension3, 1>&, const Mesh<Dimension3>&, int, int) const;
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ApplyRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Real_wp, 1>&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ApplyRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Complex_wp, 1>&);
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Real_wp, 1>&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, TinyVector<Complex_wp, 1>&);
  
  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, VectReal_wp&);

  SELDON_EXTERN template
  void FiniteElementH1<Dimension3>::ApplyInverseRotationCyclic(int n, FftInterface<Complex_wp>&, VectComplex_wp&);
  
}
