#include "MontjoieFlag.hxx"

#include "FiniteElement/MontjoieFiniteElementHeader.hxx"
#include "FiniteElement/MontjoieFiniteElementInline.hxx"

#ifndef SELDON_WITH_COMPILED_LIBRARY
#include "FiniteElement/FiniteElementHcurlAxi.cxx"
#include "FiniteElement/Quadrangle/QuadrangleHcurlAxi.cxx"
#endif

namespace Montjoie
{

  SELDON_EXTERN template class ElementReference<Dimension2, 4>;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeH(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeH(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeE(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeE(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChE(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChE(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChH(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChH(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeHteta(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeHteta(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeEteta(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChTransposeEteta(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChEteta(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChEteta(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChHteta(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyChHteta(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhTransposeEteta(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhTransposeEteta(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhTransposeE(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhTransposeE(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhEteta(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhEteta(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhE(const VectReal_wp&, VectReal_wp&) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhE(const VectComplex_wp&, VectComplex_wp&) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhTangential(const VectReal_wp&, VectReal_wp&, int num_loc) const;
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::ApplyRhTangential(const VectComplex_wp&, VectComplex_wp&, int num_loc) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeGaussIntegralSurface(const Vector<Matrix2_2>&, const VectReal_wp&, const VectReal_wp&,
			      Vector<Vector<Real_wp> > &, Vector<Vector<Real_wp> >&,
			      const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
			      const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeGaussIntegralSurface(const Vector<Matrix2_2>&, const VectReal_wp&, const VectReal_wp&,
			      Vector<Vector<Complex_wp> > &, Vector<Vector<Complex_wp> >&,
			      const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
			      const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  GetCurlFromGradient(const Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&);

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  GetCurlFromGradient(const Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&);
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeValueNodalBoundary(const Vector<Real_wp>&, Vector<Real_wp>&,
			    const ElementReference<Dimension2, 4>&,
			    const Mesh<Dimension2>&, int, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeValueNodalBoundary(const Vector<Complex_wp>&, Vector<Complex_wp>&,
			    const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeQuadratureValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			  const Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&, 
			  Vector<Vector<Real_wp> >&, bool, bool,
			  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeQuadratureValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			  const Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
			  Vector<Vector<Complex_wp> >&, bool, bool,
			  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeNodalValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		     const Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&,
		     const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeNodalValues(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		     const Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
		     const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeValueBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		       const Vector<Vector<Real_wp> >& feval, Vector<Vector<TinyVector<Real_wp, 3> > >& ,
		       const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeValueBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		       const Vector<Vector<Complex_wp> >& feval, Vector<Vector<TinyVector<Complex_wp, 3> > >& ,
		       const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeGradientBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			  const Vector<Vector<Real_wp> >&, Vector<Vector<TinyVector<Real_wp, 3> > >&,
			  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeGradientBoundary(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			  const Vector<Vector<Complex_wp> >&, Vector<Vector<TinyVector<Complex_wp, 3> > >&,
			  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeProjectionDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		       Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&,
		       const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
		       const MeshNumbering<Dimension2>&, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeProjectionDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		       Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
		       const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
		       const MeshNumbering<Dimension2>&, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeProjectionSurfaceDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			      Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&,
			      const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
			      const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeProjectionSurfaceDof(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			      Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
			      const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
			      const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegral(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		  Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&,
		  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
		  const MeshNumbering<Dimension2>&, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegral(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		  Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
		  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
		  const MeshNumbering<Dimension2>&, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralH(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		   Vector<Real_wp>&, Vector<Real_wp>&, Vector<Real_wp>&, const ElementReference<Dimension2, 4>&,
		   const Mesh<Dimension2>&, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralH(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
		   Vector<Complex_wp>&, Vector<Complex_wp>&, Vector<Complex_wp>&, const ElementReference<Dimension2, 4>&,
		   const Mesh<Dimension2>&, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			  Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&,
			  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
			  const MeshNumbering<Dimension2>&,  int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			  Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
			  const ElementReference<Dimension2, 4>&, const Mesh<Dimension2>&,
			  const MeshNumbering<Dimension2>&,  int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralSurface(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			 Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&,
			 const ElementReference<Dimension2, 4>&,
			 const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralSurface(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
			 Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
			 const ElementReference<Dimension2, 4>&,
			 const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralSurfaceGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
				 Vector<Vector<Real_wp> >&, Vector<Vector<Real_wp> >&,
				 const ElementReference<Dimension2, 4>&,
				 const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, int, int) const;

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ComputeIntegralSurfaceGradient(const SetPoints<Dimension2>&, const SetMatrices<Dimension2>&,
				 Vector<Vector<Complex_wp> >&, Vector<Vector<Complex_wp> >&,
				 const ElementReference<Dimension2, 4>&,
				 const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, int, int) const;
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ApplyRotationCyclic(int, FftInterface<Complex_wp>&, TinyVector<Real_wp, 3>&);

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ApplyRotationCyclic(int, FftInterface<Complex_wp>&, TinyVector<Complex_wp, 3>&);
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ApplyInverseRotationCyclic(int, FftInterface<Complex_wp>& fft_interface, TinyVector<Real_wp, 3>& val_u);

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ApplyInverseRotationCyclic(int, FftInterface<Complex_wp>& fft_interface, TinyVector<Complex_wp, 3>& val_u);
  
  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ApplyInverseRotationCyclic(int, FftInterface<Complex_wp>& fft_interface, Vector<Real_wp>& val_u);

  SELDON_EXTERN template void ElementReference<Dimension2, 4>::
  ApplyInverseRotationCyclic(int, FftInterface<Complex_wp>& fft_interface, Vector<Complex_wp>& val_u);
  
}
