#include "MontjoieFlag.hxx"

#include "FiniteElement/MontjoieFiniteElementHeader.hxx"
#include "FiniteElement/MontjoieFiniteElementInline.hxx"

#ifndef SELDON_WITH_COMPILED_LIBRARY
#include "Harmonic/VarFiniteElement.cxx"
#endif

namespace Montjoie
{
  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension1, 1>;

  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension2, 1>;
  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension2, 2>;
  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension2, 3>;
  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension2, 4>;
  
  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension3, 1>;
  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension3, 2>;
  SELDON_EXTERN template class VarFiniteElementEnum_Base<Dimension3, 3>;

  SELDON_EXTERN template class VarFiniteElementEnum<Dimension1, 1>;
  
  SELDON_EXTERN template class VarFiniteElementEnum<Dimension2, 1>;
  SELDON_EXTERN template class VarFiniteElementEnum<Dimension2, 2>;
  SELDON_EXTERN template class VarFiniteElementEnum<Dimension2, 3>;
  SELDON_EXTERN template class VarFiniteElementEnum<Dimension2, 4>;
  
  SELDON_EXTERN template class VarFiniteElementEnum<Dimension3, 1>;
  SELDON_EXTERN template class VarFiniteElementEnum<Dimension3, 2>;
  SELDON_EXTERN template class VarFiniteElementEnum<Dimension3, 3>;

  SELDON_EXTERN template void VarFiniteElement_Base::GetTypeIntegrationBoundary(const Mesh<Dimension3>&, const MeshNumbering<Dimension3>&, const VarFiniteElement<Dimension3, 1>&, int&, int&, int&);

  SELDON_EXTERN template void VarFiniteElement_Base::GetTypeIntegrationBoundary(const Mesh<Dimension3>&, const MeshNumbering<Dimension3>&, const VarFiniteElement<Dimension3, 2>&, int&, int&, int&);

  SELDON_EXTERN template void VarFiniteElement_Base::GetTypeIntegrationBoundary(const Mesh<Dimension3>&, const MeshNumbering<Dimension3>&, const VarFiniteElement<Dimension3, 3>&, int&, int&, int&);


  SELDON_EXTERN template void VarFiniteElement_Base::GetTypeIntegrationBoundary(const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, const VarFiniteElement<Dimension2, 1>&, int&, int&, int&);

  SELDON_EXTERN template void VarFiniteElement_Base::GetTypeIntegrationBoundary(const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, const VarFiniteElement<Dimension2, 2>&, int&, int&, int&);

  SELDON_EXTERN template void VarFiniteElement_Base::GetTypeIntegrationBoundary(const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, const VarFiniteElement<Dimension2, 3>&, int&, int&, int&);

  SELDON_EXTERN template void VarFiniteElement_Base::GetTypeIntegrationBoundary(const Mesh<Dimension2>&, const MeshNumbering<Dimension2>&, const VarFiniteElement<Dimension2, 4>&, int&, int&, int&);

  
  SELDON_EXTERN template VarFiniteElement<Dimension1, 1>::~VarFiniteElement();
  SELDON_EXTERN template void VarFiniteElement<Dimension1, 1>::ClearFiniteElement();

  SELDON_EXTERN template class VarFiniteElement<Dimension2, 1>;
  SELDON_EXTERN template class VarFiniteElement<Dimension2, 2>;
  SELDON_EXTERN template class VarFiniteElement<Dimension2, 3>;
  SELDON_EXTERN template class VarFiniteElement<Dimension2, 4>;

  SELDON_EXTERN template class VarFiniteElement<Dimension3, 1>;
  SELDON_EXTERN template class VarFiniteElement<Dimension3, 2>;
  SELDON_EXTERN template class VarFiniteElement<Dimension3, 3>;



}
