#include "MontjoieFlag.hxx"

#include "Harmonic/MontjoieHarmonicHeader.hxx"
#include "Harmonic/MontjoieHarmonicInline.hxx"

#ifndef SELDON_WITH_COMPILED_LIBRARY
#include "Source/DefineSourceElliptic.cxx"
#endif

namespace Montjoie
{
  
  SELDON_EXTERN template class VarSourceProblem_Dim<Dimension2>;
  SELDON_EXTERN template class VarSourceProblem_Dim<Dimension3>;

  SELDON_EXTERN template class VarSourceProblem_Cplx<Real_wp, Dimension2>;
  SELDON_EXTERN template class VarSourceProblem_Cplx<Real_wp, Dimension3>;
  SELDON_EXTERN template class VarSourceProblem_Cplx<Complex_wp, Dimension2>;
  SELDON_EXTERN template class VarSourceProblem_Cplx<Complex_wp, Dimension3>;

  SELDON_EXTERN template class VarSourceProblem_Fem<Dimension2, 1>;
  SELDON_EXTERN template class VarSourceProblem_Fem<Dimension2, 2>;
  SELDON_EXTERN template class VarSourceProblem_Fem<Dimension2, 3>;
  SELDON_EXTERN template class VarSourceProblem_Fem<Dimension2, 4>;

  SELDON_EXTERN template class VarSourceProblem_Fem<Dimension3, 1>;
  SELDON_EXTERN template class VarSourceProblem_Fem<Dimension3, 2>;
  SELDON_EXTERN template class VarSourceProblem_Fem<Dimension3, 3>;

  SELDON_EXTERN template class VarSourceProblem<Real_wp, Dimension2, 1>;
  SELDON_EXTERN template class VarSourceProblem<Real_wp, Dimension2, 2>;
  SELDON_EXTERN template class VarSourceProblem<Real_wp, Dimension2, 3>;
  SELDON_EXTERN template class VarSourceProblem<Real_wp, Dimension2, 4>;

  SELDON_EXTERN template class VarSourceProblem<Real_wp, Dimension3, 1>;
  SELDON_EXTERN template class VarSourceProblem<Real_wp, Dimension3, 2>;
  SELDON_EXTERN template class VarSourceProblem<Real_wp, Dimension3, 3>;

  SELDON_EXTERN template class VarSourceProblem<Complex_wp, Dimension2, 1>;
  SELDON_EXTERN template class VarSourceProblem<Complex_wp, Dimension2, 2>;
  SELDON_EXTERN template class VarSourceProblem<Complex_wp, Dimension2, 3>;
  SELDON_EXTERN template class VarSourceProblem<Complex_wp, Dimension2, 4>;

  SELDON_EXTERN template class VarSourceProblem<Complex_wp, Dimension3, 1>;
  SELDON_EXTERN template class VarSourceProblem<Complex_wp, Dimension3, 2>;
  SELDON_EXTERN template class VarSourceProblem<Complex_wp, Dimension3, 3>;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 1>::
  AddDiracSourceGen(const Real_wp&, const VectR2&, const Vector<VectReal_wp>&, const IVect&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 2>::
  AddDiracSourceGen(const Real_wp&, const VectR2&, const Vector<VectReal_wp>&, const IVect&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 3>::
  AddDiracSourceGen(const Real_wp&, const VectR2&, const Vector<VectReal_wp>&, const IVect&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 4>::
  AddDiracSourceGen(const Real_wp&, const VectR2&, const Vector<VectReal_wp>&, const IVect&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 1>::
  AddDiracSourceGen(const Real_wp&, const VectR3&, const Vector<VectReal_wp>&, const IVect&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 2>::
  AddDiracSourceGen(const Real_wp&, const VectR3&, const Vector<VectReal_wp>&, const IVect&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 3>::
  AddDiracSourceGen(const Real_wp&, const VectR3&, const Vector<VectReal_wp>&, const IVect&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension3>* >&) const;


  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 1>::
  AddDiracSourceGen(const Complex_wp&, const VectR2&, const Vector<VectComplex_wp>&, const IVect&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 2>::
  AddDiracSourceGen(const Complex_wp&, const VectR2&, const Vector<VectComplex_wp>&, const IVect&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 3>::
  AddDiracSourceGen(const Complex_wp&, const VectR2&, const Vector<VectComplex_wp>&, const IVect&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 4>::
  AddDiracSourceGen(const Complex_wp&, const VectR2&, const Vector<VectComplex_wp>&, const IVect&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 1>::
  AddDiracSourceGen(const Complex_wp&, const VectR3&, const Vector<VectComplex_wp>&, const IVect&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 2>::
  AddDiracSourceGen(const Complex_wp&, const VectR3&, const Vector<VectComplex_wp>&, const IVect&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 3>::
  AddDiracSourceGen(const Complex_wp&, const VectR3&, const Vector<VectComplex_wp>&, const IVect&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension3>* >&) const;


  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 1>::
  AddDiracSourceGen(const Real_wp&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 1>::
  AddDiracSourceGen(const Complex_wp&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 2>::
  AddDiracSourceGen(const Real_wp&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 2>::
  AddDiracSourceGen(const Complex_wp&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 3>::
  AddDiracSourceGen(const Real_wp&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 3>::
  AddDiracSourceGen(const Complex_wp&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 4>::
  AddDiracSourceGen(const Real_wp&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 4>::
  AddDiracSourceGen(const Complex_wp&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;



  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 1>::
  AddDiracSourceGen(const Real_wp&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 1>::
  AddDiracSourceGen(const Complex_wp&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 2>::
  AddDiracSourceGen(const Real_wp&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 2>::
  AddDiracSourceGen(const Complex_wp&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 3>::
  AddDiracSourceGen(const Real_wp&, Vector<VectReal_wp>&, Vector<VirtualSourceFEM<Real_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension3, 3>::
  AddDiracSourceGen(const Complex_wp&, Vector<VectComplex_wp>&, Vector<VirtualSourceFEM<Complex_wp, Dimension3>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 1>::
  AddDiracSourceAxisym(const Real_wp&, const Vector<bool>&, int, Vector<VectReal_wp>&, const VectR3&, Vector<VirtualSourceFEM<Real_wp, Dimension2>* >&) const;

  SELDON_EXTERN template void VarSourceProblem_Fem<Dimension2, 1>::
  AddDiracSourceAxisym(const Complex_wp&, const Vector<bool>&, int, Vector<VectComplex_wp>&, const VectR3&, Vector<VirtualSourceFEM<Complex_wp, Dimension2>* >&) const;
  
}
