#ifndef MONTJOIE_FILE_QUADRANGLE_HCURL_AXI_CXX

namespace Montjoie
{
  
  //! how to number the mesh
  /*!
    \param[out] map 
   */
  void QuadrangleHcurlAxi::
  ConstructNumberMap(NumberMap& nmap, int dg) const
  {
    int order = this->finite_element_h1.GetOrder();
    nmap.SetNbDofVertex(order, 1);
    nmap.SetNbDofEdge(order, 2*order-1);
    nmap.SetNbDofQuadrangle(order, nb_dof_loc-nb_dof_boundaries);
    
    nmap.SetEqualEdgesDofSymmetry(order, 2*order-1);
    for (int i = 0; i < order; i++)
      nmap.SetEdgesDofSymmetry(order, order-1-i, i, true);
    
    for (int i = 0; i < (order-1); i++)
      nmap.SetEdgesDofSymmetry(order, 2*order-2-i, i+order, false);
    
  }
  
  
  //! how to number the mesh
  /*!
    \param[out] map 
   */
  void TriangleHcurlAxi::
  ConstructNumberMap(NumberMap& nmap, int dg) const
  {
    int order = this->finite_element_h1.GetOrder();
    nmap.SetNbDofVertex(order, 1);
    nmap.SetNbDofEdge(order, 2*order-1);
    nmap.SetNbDofQuadrangle(order, nb_dof_loc-nb_dof_boundaries);
    
    nmap.SetEqualEdgesDofSymmetry(order, 2*order-1);
    for (int i = 0; i < order; i++)
      nmap.SetEdgesDofSymmetry(order, order-1-i, i, true);
    
    for (int i = 0; i < (order-1); i++)
      nmap.SetEdgesDofSymmetry(order, 2*order-2-i, i+order, false);
    
  }
  
}

#define MONTJOIE_FILE_QUADRANGLE_HCURL_AXI_CXX
#endif

