#ifndef MONTJOIE_FILE_QUADRANGLE_HCURL_AXI_HXX

namespace Montjoie
{
  
  //! finite element used for maxwell axi-symmetric equations
  /*!
    The unknown E_theta is discretized in H^1 (nodal Gauss-Lobatto points)
    the unknown (E_r,E_z) is discretized in H(curl)
    with Nedelec first family (edge finite element)
   */
  class QuadrangleHcurlAxi : 
    public FiniteElementHcurlAxi<QuadrangleGauss, QuadrangleHcurlGaussFirstFamily>
  {
  public :
    // how to number finite element
    void ConstructNumberMap(NumberMap& nmap, int dg) const;
    
  };
  
  class TriangleHcurlAxi : 
    public FiniteElementHcurlAxi<TriangleClassical, TriangleHcurlFirstFamily>
  {
  public :
    // how to number finite element
    void ConstructNumberMap(NumberMap& nmap, int dg) const;
    
  };
  
  ostream& operator <<(ostream& out, const QuadrangleHcurlAxi& e);
  
}

#define MONTJOIE_FILE_QUADRANGLE_HCURL_AXI_HXX
#endif

