#ifndef MONTJOIE_FILE_PARALLEL_MESH_FUNCTIONS_HXX

namespace Montjoie
{

  template<class Dimension>
  struct ParamParallelMesh
  {
    IVect num;
    VectReal_wp all_param;
    typename Dimension::VectR_N PointsEdgeRef, TranslatPeriodicEdge;
    IVect NumBoundary, NumDofNeighbor, NumElem, NumDof;
    IVect MinimalProc, OffsetDofV, NumDofPML;
    int dg_form, nodl_mesh;
    
  };

  template<class Dimension>
  void SendMeshToProcessor(const Mesh<Dimension>& glob_mesh,
                           const MeshNumbering<Dimension>& glob_mesh_num,
			   const IVect& NumElement, const IVect& Epart, const IVect& NumLoc,
                           Mesh<Dimension>& mesh, int proc, const MPI_Comm& comm, ParamParallelMesh<Dimension>& param, int tag = 48);                           

  template<class Dimension>
  void RecvMeshFromProcessor(Mesh<Dimension>& mesh, MeshNumbering<Dimension>& mesh_num,
			     Vector<IVect>& ConnecEdge, IVect& MatchingProc, Vector<IVect>& MatchingDofs,
                             ParamParallelMesh<Dimension>& param, int proc, MPI_Comm& comm, int tag = 48);
  
}

#define MONTJOIE_FILE_PARALLEL_MESH_FUNCTIONS_HXX
#endif
