// Copyright (C) 2003-2011 Marc Duruflé
// Copyright (C) 2001-2011 Vivien Mallet
//
// This file is part of the linear-algebra library Seldon,
// http://seldon.sourceforge.net/.
//
// Seldon is free software; you can redistribute it and/or modify it under the
// terms of the GNU Lesser General Public License as published by the Free
// Software Foundation; either version 2.1 of the License, or (at your option)
// any later version.
//
// Seldon is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
// more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Seldon. If not, see http://www.gnu.org/licenses/.


#ifndef SELDON_FILE_SELDON_COMPLEX_MATRIX_HEADER_HXX

// additional classes and functions for sparse complex matrices
// where real part and imaginary part are stored separately
#include "matrix_sparse/complex/Matrix_ComplexSparse.hxx"
#include "matrix_sparse/complex/Matrix_SymComplexSparse.hxx"
#include "matrix_sparse/complex/Matrix_ArrayComplexSparse.hxx"

// functions related to complex matrices
#include "matrix_sparse/complex/Functions_MatVectComplex.hxx"
#include "matrix_sparse/complex/Functions_MatrixComplex.hxx"
#include "matrix_sparse/complex/Matrix_ComplexConversions.hxx"

#define SELDON_FILE_SELDON_COMPLEX_MATRIX_HEADER_HXX
#endif
